package com.ttstd.dialer.gson;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.List;
import java.util.Map;
import java.util.Objects;


public class GsonUtils {
    //https://blog.csdn.net/zte1055889498/article/details/122400299

    public static JsonObject getJsonObject(String jsonString) {
        JsonObject jsonObject = JsonParser.parseString(jsonString).getAsJsonObject();
        return jsonObject;
    }

    private static final Gson gson;
    private static final Gson exposeGson;

    static {
        GsonBuilder builder = new GsonBuilder();
        builder.registerTypeAdapterFactory(new NullStringToEmptyAdapterFactory());
        builder.registerTypeAdapter(Integer.class, new IntegerDefault0Adapter());
        builder.registerTypeAdapter(int.class, new IntegerDefault0Adapter());
        builder.disableHtmlEscaping();
        builder.enableComplexMapKeySerialization();
        // builder.excludeFieldsWithoutExposeAnnotation();
        builder.setDateFormat("yyyy-MM-dd HH:mm:ss");
        gson = builder.create();
        exposeGson = new GsonBuilder()
                .excludeFieldsWithoutExposeAnnotation()
                .create();
    }

    public static Type makeJavaType(Type rawType, Type... typeArguments) {
        return TypeToken.getParameterized(rawType, typeArguments).getType();
    }

    public static String toString(Object value) {
        if (Objects.isNull(value)) {
            return null;
        }
        if (value instanceof String) {
            return (String) value;
        }
        return toJSONString(value);
    }

    public static String toJSONString(Object value) {
        return gson.toJson(value);
    }

    public static String toExposeJSONString(Object value) {
        return gson.toJson(value);
    }


    public static String toPrettyString(Object value) {
        return gson.newBuilder().setPrettyPrinting().create().toJson(value);
    }

    public static JsonElement fromJavaObject(Object value) {
        JsonElement result = null;
        if (Objects.nonNull(value) && (value instanceof String)) {
            result = parseObject((String) value);
        } else {
            result = gson.toJsonTree(value);
        }
        return result;
    }

    public static JsonElement parseObject(String content) {
        return JsonParser.parseString(content);
    }

    public static JsonElement getJsonElement(JsonObject node, String name) {
        return node.get(name);
    }

    public static JsonElement getJsonElement(JsonArray node, int index) {
        return node.get(index);
    }

    public static <T> T toJavaObject(JsonElement node, Class<T> clazz) {
        return gson.fromJson(node, clazz);
    }

    public static <T> T toJavaObject(JsonElement node, Type type) {
        return gson.fromJson(node, type);
    }

    public static <T> T toJavaObject(JsonElement node, TypeToken<?> typeToken) {
        return toJavaObject(node, typeToken.getType());
    }

    public static <E> List<E> toJavaList(JsonElement node, Class<E> clazz) {
        return toJavaObject(node, makeJavaType(List.class, clazz));
    }

    public static List<Object> toJavaList(JsonElement node) {
        return toJavaObject(node, new TypeToken<List<Object>>() {
        }.getType());
    }

    public static <V> Map<String, V> toJavaMap(JsonElement node, Class<V> clazz) {
        return toJavaObject(node, makeJavaType(Map.class, String.class, clazz));
    }

    public static Map<String, Object> toJavaMap(JsonElement node) {
        return toJavaObject(node, new TypeToken<Map<String, Object>>() {
        }.getType());
    }

    public static <T> T toJavaObject(String content, Class<T> clazz) {
        JsonObject jsonObject = getJsonObject(content);
        String jsonString = jsonObject.toString();
        return gson.fromJson(jsonString, clazz);
    }

    public static <T> T toJavaObject(String content, Type type) {
        return gson.fromJson(content, type);
    }

    public static <T> T toJavaObject(String content, TypeToken<?> typeToken) {
        return toJavaObject(content, typeToken.getType());
    }

    public static <E> List<E> toJavaList(String content, Class<E> clazz) {
        return toJavaObject(content, makeJavaType(List.class, clazz));
    }

    public static List<Object> toJavaList(String content) {
        return toJavaObject(content, new TypeToken<List<Object>>() {
        }.getType());
    }

    public static <V> Map<String, V> toJavaMap(String content, Class<V> clazz) {
        return toJavaObject(content, makeJavaType(Map.class, String.class, clazz));
    }

    public static Map<String, Object> toJavaMap(String content) {
        return toJavaObject(content, new TypeToken<Map<String, Object>>() {
        }.getType());
    }
}
